module Destiny
  module User

    def permitted?(*privileges)
      return true if is_admin?

      begin
        permitted = role_hash.dig(*privileges)
        permitted = false unless !!permitted == permitted
      rescue Exception => e
        permitted = false
      end

      permitted
    end

    def owner?(obj)
      return id == obj.user_id if obj.respond_to? :user_id
    end

    def role_hash
      @role_hash = {}
      roles.map(&:to_hash).each_entry { |h| @role_hash.deep_merge!(h) }
      @role_hash.with_indifferent_access
    end

    def admin?
      return true if role_hash.try(:[], 'system').try(:[], 'administrator')
    end

    def has_role?(role_name)
      roles.pluck(:name).count(role_name.to_s) > 0
    end

  end
end
